=== src/camel/tests/message/CMakeLists.txt ===
set(TESTS_SKIP
	test1
	test2
	test4
)

add_camel_tests(message TESTS_SKIP OFF)
