=== debian/changelog ===
evolution-data-server (3.50.1-1+rb1) unstable; urgency=medium

  * Team upload
  * New upstream release
    - Bug Fixes:
      + Update default calendar colors
        (https://gitlab.gnome.org/GNOME/evolution-data-server/-/issues/494)
      + Mail: Correct conversion of UTF-16 encoded text files
        (https://gitlab.gnome.org/GNOME/evolution/-/issues/1436)

 -- Amin Bandali <bandali@ubuntu.com>  Tue, 24 Oct 2023 06:36:05 -0400
